package net.ericaro.neobin;

import java.util.Set;

public class UndefinedTransitionException extends RuntimeException {

	private static final String MISSING_TRANSITION = "Missing Transition Definition in the XML. The follow transitions are used in the expression, but are not defined in the Transitions element: ";

	public UndefinedTransitionException() {
	}

	public UndefinedTransitionException(String message) {
		super(message);
	}

	public UndefinedTransitionException(Throwable cause) {
		super(cause);
	}

	public UndefinedTransitionException(String message, Throwable cause) {
		super(message, cause);
	}

	public UndefinedTransitionException(Set<String> undefinedTransitionNames) {
		super(message(undefinedTransitionNames) );
	}

	protected static String message(Set<String> undefinedTransitionNames) {
		StringBuilder sb = new StringBuilder();
		if (MISSING_TRANSITION != null)
			sb.append(MISSING_TRANSITION);
		boolean first = true;
		for (Object argument : undefinedTransitionNames) {
			if (first)
				first = false;
			else
				sb.append(", ");
			sb.append(argument);
		}
		if ("" != null)
			sb.append("");
		return sb.toString();
	}
}
